local GuildWelcomer = _G['GuildWelcomer'];
local LAM = LibStub('LibAddonMenu-2.0')

function GuildWelcomer:CreateSettingsWindow()
    local panelData = {
        type = "panel",
        name = "Guild Welcomer",
        displayName = "Guild Welcomer",
        author = "decaprime",
        version = GuildWelcomer.Version,
        slashCommand = "/guildwelcomer",
        registerForRefresh = true,
        registerForDefaults = false,
    }
    
    local cntrlOptionsPanel = LAM:RegisterAddonPanel("GuildWelcomer", panelData)
        
    local optionsData = {
        [1] = {
            type = "header",
            name = "General Settings"
        },
        [2] = {
            type = "checkbox",
            name = "Play Sound",
            tooltip = "Plays a sound notification when a guild member joins and you have the welcomer enabled for that guild.",
            default = false,
            disabled = false,
            getFunc = function() return GuildWelcomer.Saved.DoPlaySound end,
            setFunc = function(newValue)
                GuildWelcomer.Saved.DoPlaySound = newValue
            end,
        },
        [3] = {
            type = "header",
            name = "Welcome Messages"
        },
        [4] = {
            type = "description",
            text = "Here you will find settings for each of the guilds you're currently in. \n\nUse  |c00FF00%PLAYER%|r as a placeholder that will be replaced with the player invited."
        },
    }
    
	for i,guildName in ipairs(GuildWelcomer.CurrentGuilds) do
        optionsData[#optionsData + 1] = {
            type = "header",
            name = guildName
        }
        local checkbox = {
            type = "checkbox",
            name = "Auto-Welcome",
            tooltip = "When ON the message will be sent.",
            default = false,
            disabled = false,
            getFunc = function() return GuildWelcomer.Saved.Guilds[guildName].AutoWelcome end,
            setFunc = function(newValue)
                GuildWelcomer.Saved.Guilds[guildName].AutoWelcome = newValue
            end,
        }
        local editbox = {
            type = "editbox",
            name = "Message",
            tooltip = "This message will be  when |c00FF00%PLAYER%|r joins the guild.",
            isExtraWide = true,
            isMultiline = false,
            disabled = function() return not GuildWelcomer.Saved.Guilds[guildName].AutoWelcome end,
            getFunc = function() return GuildWelcomer.Saved.Guilds[guildName].Message end,
            setFunc = function(newValue)
                GuildWelcomer.Saved.Guilds[guildName].Message = newValue
            end,
        }
        optionsData[#optionsData + 1] = checkbox
        optionsData[#optionsData + 1] = editbox
    end
    
    LAM:RegisterOptionControls("GuildWelcomer", optionsData)
end
